var $ = jQuery;
$(function() {
    var g_col;
    var g_row;
    var g_isFocusCell = false; // Стоит фокус на ячейки или нет
    var g_oldRateCell = null;
    var g_submoduleID = null;
    var g_studentID = null;
    var g_submoduleTitle = "";
    var g_submoduleMaxRate = 0;
    var g_stdName = "";
    var jTdInfo_wrap = $("#tdInfo_wrap");
    var jTdInfo = jTdInfo_wrap.children('#tdInfo');

    var g_URL = (window.location.href).split("/");
    var g_disciplineID = g_URL[g_URL.length - 1];

    // Настройки дисциплины:
    // + ID - id дисциплины
    // + studyGroupID_Filter - studyGroupID для фильтра (Эффект памяти)
    var json_settings = $.parseJSON($("#hidden_div").html());
    console.log(json_settings);
    $("#hidden_div").remove();
    filterGroups(json_settings.StudyGroupID_Filter);
    $(".groupSelector [value='"+ json_settings.StudyGroupID_Filter +"']").attr("selected", "selected");

    // Скрываем все остальные группы
    // 0 - показать все
    function filterGroups(groupID) {
        if (groupID == 0) {
            $(".studentsRate tbody")
            .children()
            .each( function() {
                    $(this).show();
            });
        } else {
            $(".studentsRate tbody")
                .children(":gt(2)")
                .each( function() {
                    if ($(this).hasClass("group_" + groupID))
                        $(this).show();
                    else
                        $(this).hide();
                });
        }
    }

    // Ставим подстветку
    function TdFocus(jThis){
        g_col = jThis.attr('id');
        	g_col = parseInt(g_col.substr(4));
        g_row = jThis.parent('tr').attr('id');
        	g_row = parseInt(g_row.substr(4));
        
        g_oldRateCell = jThis.children("input").val();
        $("td#col_" + g_col + ".commonCell").each(function(){
            $(this).children('input').css("background-color", "#f1f1f1");
        });
        $("td#col_" + g_col + ".staticCell").each(function(){
            $(this).children('input').css("background-color", "#f1f1f1");
        });

        $("tr#row_" + g_row + " .commonCell").each(function(){
            $(this).children('input').css("background-color", "#f1f1f1");
        });
        $("tr#row_" + g_row + " .staticCell").each(function(){
            $(this).css("background-color", "#f1f1f1");
            $(this).children('input').css("background-color", "#f1f1f1");
        });
        jThis.children('input').css("background-color", "#fff");
    }
    
    // Убираем подстветку
    function TdUnFocus(){
        $("td#col_" + g_col + ".commonCell").each(function(){
            $(this).children('input').css("background-color", "#fff");
        });
        $("td#col_" + g_col + ".staticCell").each(function(){
            $(this).children('input').css("background-color", "#fff");
        });

        $("tr#row_" + g_row + " .commonCell").each(function(){
            $(this).children('input').css("background-color", "#fff");
        });
        $("tr#row_" + g_row + " .staticCell").each(function(){
            $(this).css("background-color", "#fff");
            $(this).children('input').css("background-color", "#fff");
        });
    }
    
    function TdInfo(jThis) {
        // Получаем подмодуль
        g_submoduleID = parseInt($(".RatingTableSubmodulesHeadMaxRate .col_"+g_col+":first").attr("id"));
        g_submoduleTitle = $(".RatingTableSubmodulesHead .col_"+g_col+":first").text();
        if ($(".RatingTableSubmodulesHead .col_"+g_col+":first").length < 1 && $(".RatingTableModulesHead .bonus").length > 0 ) 
            g_submoduleTitle = 'Бонусные баллы';
		g_submoduleMaxRate = parseInt($(".RatingTableSubmodulesHeadMaxRate #"+g_submoduleID).children("input").val());

        console.log(g_submoduleMaxRate);

        if (jThis.attr("class").indexOf("additionalCell") >= 0)
        {
        	var t = parseInt(jThis.siblings(".semesterRateResultCell").text());
        	if (t > 31 && t < 39)
        		g_submoduleMaxRate = 38 - t;
        	else g_submoduleMaxRate = 0;
        	
            //if (g_submoduleMaxRate > 0)
        	//	jThis.children("input").attr("placeholder", "макс. "+g_submoduleMaxRate);
        	//else jThis.children("input").attr("placeholder", "---");
        }

        // Получаем студента
        g_studentID = jThis.siblings('.studentCell').attr("id");
        	g_studentID = g_studentID.substr(8);
        	
        g_stdName = jThis.siblings('.studentCell').text();

        jTdInfo_wrap.show();
        jTdInfo.children("#student").children("b").html(g_stdName);
        jTdInfo.children("#submodule").children("b").html(g_submoduleTitle);
        jTdInfo.children("#maxRate").children("b").html(g_submoduleMaxRate);

        //if (jThis.children('.tdInfo').length <= 0)
        //  jThis.append("<div class='tdInfo'>"+g_submoduleTitle+"<br>"+g_stdName+"</div>");
    }

    function UnsetTdInfo(jThis){
        //jThis.children(".tdInfo").remove();
        jTdInfo_wrap.hide();
        g_submoduleID = null;
        g_studentID = null;
        g_submoduleMaxRate = 0;
    }

    function Rating(jThis, oldRate) {
        oldRate = parseInt(oldRate);
        // Здесь jThis - div rateCell, а не input, который является дочкой
        jThis.children("input").attr("disabled", true);

        var newRate = 0;
        if (jThis.children("input").val() !== "")
            newRate = parseInt(jThis.children("input").val());
        //var maxRate = parseInt($(".RatingTableSubmodulesHeadMaxRate #"+g_submoduleID).children("input").val());

        var rateResult = parseInt(jThis.siblings(".rateResultCell").text()) - oldRate + newRate;

		// страница сессии
		if (jThis.attr("class").indexOf("attemptCell") >= 0)
		{
			//if (jThis.siblings(".semesterRateResultCell ").length > 0) {
				rateResult = parseInt(jThis.siblings(".semesterRateResultCell").text()) + newRate; // todo

			jThis.siblings(".additionalCell").each(function(){
				if ($(this).children("input").val() !== "")
				rateResult += parseInt($(this).children("input").val());
			});
			//}
		}
		//end страница сессии

        if (rateResult > 100) {
            jThis.children("input").val(oldRate);
            EventInspector_ShowMsg("Сумма баллов не может привышать 100", "error");
            jThis.children("input").removeAttr("disabled");
        }
        else 
        {
          	if ((json_settings.ExamType == "exam") && (rateResult - parseInt(jThis.siblings(".examCell").text())) > 60)
          	{
	            jThis.children("input").val(oldRate);
	            EventInspector_ShowMsg("Сумма баллов не может привышать 60 (т.к. 40 на экзамен)", "error");
	            jThis.children("input").removeAttr("disabled");
	            return -1;
          	}

            if (newRate <= g_submoduleMaxRate) 
            {
                $.ajax({
                    type: "POST",
                    url: URLdir + "handler/rating/setRate",
                    data: "student="+g_studentID+"&submodule="+g_submoduleID+"&rate="+newRate,
                    statusCode: {
                       403: function() { 
                            EventInspector_ShowMsg("Сессия истекла", "error");
                            jThis.children("input").val(oldRate);
                            jThis.children("input").removeAttr("disabled");
			                window.location.replace(URLdir);
                    	},
                       200: function(data) {
                            data = $.parseJSON(data);
                            if(data.success === true) {
                                jThis.siblings(".rateResultCell").text(rateResult);
                                EventInspector_ShowMsg("Балл добавлен/изменен", "success");
                            }
                            else EventInspector_ShowMsg("Не удалось добавить/изменить балл", "error");
                            jThis.children("input").removeAttr("disabled");
                       }
                    }
                });
            } 
            else {
                if (oldRate <= g_submoduleMaxRate)
                    jThis.children("input").val(oldRate);
                else
                    jThis.children("input").val("0");

                EventInspector_ShowMsg("Текущий балл превышает максимальный для данного модуля", "error");
                jThis.children("input").removeAttr("disabled");
            }
        }
    }
    
    $(".commonCell").mouseenter(function(){
        if (g_isFocusCell === false)
            TdFocus($(this));
    });
    
    $(".commonCell").mouseleave(function(){
        if (g_isFocusCell === false)
            TdUnFocus();
    });
    
    var oldRate = 0;
    $(".commonCell").focusin(function(){
        g_isFocusCell = true;
        TdFocus($(this));
        TdInfo($(this));
        if ($(this).children("input").val() !== "")
            oldRate = $(this).children("input").val();
        else oldRate = 0;
    });
    
    $(".commonCell").focusout(function(){
        g_isFocusCell = false;
        var newRate = 0;
        if ($(this).children("input").val() !== "")
            newRate = $(this).children("input").val();
        if (newRate != oldRate)
            Rating($(this), oldRate);
        TdUnFocus();
        UnsetTdInfo($(this));
    });
    
    $(".commonCell").keyup(function(e){
        
        var jThis = $(this);
        var row = g_row;
        var col = g_col;

        // При нажатие Enter (переход к оцениванию след. студента, т.е. ниже)
        if(e.keyCode==13)
            row = row + 1;

        // Стрелка вверх
        if(e.keyCode==38)
            row = row - 1;
        
        // Стрелка вправо
        if(e.keyCode==39)
            col = col + 1;
        
        // Стрелка вниз
        if(e.keyCode==40)
            row = row + 1;
        
        // Стрелка влево
        if(e.keyCode==37)
            col = col - 1;

        if ((e.keyCode >= 37 && e.keyCode <= 40) || e.keyCode == 13 ) {
            var jTempObj = $("tr#row_" + row + " td#col_" + col + ".commonCell");
            if (jTempObj.length > 0) {
                TdUnFocus();
                g_row = row;
                g_col = col;
                jTempObj.children("input").focus();
            }
        }
    });
    
    $(".commonCell input").focusin(function(){
        $(this).select();
    });
    
    // При нажатие на элемент commonCell дочерный input получает фокус
    $(".commonCell ").click(function(){
        $(this).children("input").focus();
    } );
    
    // В inputCredit (где баллы вводить) разрешаем вводить только цифры
    $(".commonCell").children("input").keydown(function(event) {
        KeyDownOnlyNumber(event);
    });



    // Фильтр по группе
    $(".groupSelector").change(function() {
        var group = $(this).val(); 
        if (group >= 0)
        {
            filterGroups(group);
            $.post(
                URLdir + "handler/rating/SelectGroup",
                {   
                    "disciplineID": g_disciplineID,
                    "groupSelected":  group 
                },
                function(data){
                    data = $.parseJSON(data);
                    if(data.success === true) {

                    }
                }
            );
        }
    });



    // Скачать таблицу оценивания в формате excel
    $(".downloadExcel").click(function(){
        $.fileDownload(URLdir + 'handler/FileCreator/GenerateExcelRatingTable', {
            httpMethod: "POST",
            data: 
            {
                'disciplineID': g_disciplineID
            },
            successCallback: function () {

            },
            failCallback: function () {

            }
        });
    });

    // Ведомость в формате excel
     $('body').on('click', '.downloadExcelStatement', function(){
        $.fileDownload(URLdir + 'handler/FileCreator/GenerateFinalForm', {
            httpMethod: "POST",
            data: 
            {
                "disciplineID": g_disciplineID,
                "studyGroupID": parseInt($(this).attr("id").substr(6))
            },
            successCallback: function () {

            },
            failCallback: function () {

            }
        });
    });

    
});


